Welcome to the Treehouse Community

The Treehouse Community is a meeting place for developers, designers, and programmers of all backgrounds and skill levels to get support. Collaborate here on code errors or bugs that you need feedback on, or asking for an extra set of eyes on your latest project. Join thousands of Treehouse students and alumni in the community today. (Note: Only Treehouse students can comment or ask questions, but non-students are welcome to browse our conversations.)

Looking to learn something new?

Treehouse offers a seven day free trial for new students. Get access to thousands of hours of content and a supportive community. Start your free trial today.

Java Java Objects (Retired) Harnessing the Power of Objects Handling Exceptions

catching...a cold/over the limit

I have tried everything it doesnt work..

Main.java
public class Main {
    public static void main(String[] args) {
        GoKart kart = new GoKart("yellow");
        if (kart.isBatteryEmpty()) {
          System.out.println("The battery is empty");
        }
        kart.drive(2);
      try{
        kart.drive(3);
      }catch(IllegalArgumentException){throw e;}
    }
}

1 Answer

Kourosh Raeen
Kourosh Raeen
23,732 Points

Hi Thomas - There should be one call to the drive() and it should be inside the try block. You have one that is above the try block. Also, in the catch block give the IllegalArgumentException some name, I used exp here. You also shouldn't have throw inside the catch block. Just print a warning for the user or use the getMessage() method to display the error message:

public class Main {
    public static void main(String[] args) {
        GoKart kart = new GoKart("yellow");
        if (kart.isBatteryEmpty()) {
          System.out.println("The battery is empty");
        }
        try {
          kart.drive(2);
        } catch (IllegalArgumentException exp) {
          System.out.println("Exception thrown!");  
          System.out.printf("The error was: %s\n", exp.getMessage());  
        }
    }
}